
package book.jmx.examples;

import javax.management.*;


public class TivoliAgent {

    // the main method of the class
    public static void main(String[] args) {

        try {
            // create the agent reference
            MBeanServer server = 
                MBeanServerFactory.createMBeanServer();

            // create reference to the MBean
            ObjectName name = 
                new ObjectName("example:name=hello");
        
            // register Hello MBean
            server.registerMBean(new Hello(), name);

        // create the adaptor instance
        com.tivoli.jmx.http_pa.Listener adaptor =
            new com.tivoli.jmx.http_pa.Listener();

        // register the adaptor MBean to the agent
        server.registerMBean(adaptor,
            new ObjectName("adaptor:protocol=HTTP"));

        // start the adaptor
        adaptor.startListener();

        }
    catch (java.io.IOException e) {
        e.printStackTrace();
    }
            
        
        catch (MBeanRegistrationException e) {
            e.printStackTrace();
        }
        catch (NotCompliantMBeanException e) {
            e.printStackTrace();
        }
        catch (MalformedObjectNameException e) {
            e.printStackTrace();
        }
        catch (InstanceAlreadyExistsException e) {
            e.printStackTrace();
        }
    }
}
