
package book.jmx.examples;

import java.util.*;
import javax.management.*;

public class ConnectorClient {

  public static void main(String[] args) {

    
    try {
      final ObjectName user = new ObjectName("test:name=user");
      
      final AsyncMBeanServer aServer = 
          ConnectorFactory.createAsyncConnector("JMS", "MyAgent");
      final RemoteMBeanServer rServer = 
          ConnectorFactory.createConnector("SOAP", "MyAgent");
      
      rServer.createMBean("book.jmx.examples.User", user);
      
      Thread jms = new Thread(new Runnable() {
       
        Attribute attr = new Attribute("Name", "Testing...");
        
        public void run() {
          try {
            System.out.println("JMS Started.");
          
            for (int i = 0; i < 5000; ++i)
              aServer.setAttribute(user, attr);
          
            System.out.println("JMS Ended.");
          }
          catch (Exception e) {
            e.printStackTrace();
          }
        }
      });
      
      Thread soap = new Thread(new Runnable() {
        
        Attribute attr = new Attribute("Name", "Testing...");
        
        public void run() {
          try {
            System.out.println("SOAP Started.");
          
            for (int i = 0; i < 5000; ++i)
              rServer.setAttribute(user, attr);
          
            System.out.println("SOAP Ended.");
          }
          catch (Exception e) {
            e.printStackTrace();
          }
        }
      });
      
      soap.start();
      jms.start();
    }
    catch (ConnectorException e) {
      e.getTargetException().printStackTrace();
    }
    catch (JMException e) {
      e.printStackTrace();
    }
  }
}
