
package book.jmx.examples;

import java.util.*;
import javax.naming.*;
import javax.management.*;

public class JMSConnectorClient implements RMIConnectorConstants, JMSConnectorConstants {

  public static void main(String[] args) {
  
    Properties props = new Properties();
    props.put(JMS_TOPIC, 
        "topic/JMSConnector"
    );
    props.put(JMS_TOPIC_CONNECTION_FACTORY,
        "ConnectionFactory"
    );
    props.put(HOST, "localhost");
    props.put(PORT, "1099");
    props.put(REMOTE_NAME, "jmx/RMIConnector");
    
    try {
      AsyncMBeanServer server = 
         ConnectorFactory.createAsyncConnector("JMS", props);
      //RemoteMBeanServer server =
      //    ConnectorFactory.createConnector("RMI", props);
      
      server.invoke(new ObjectName("adaptor:protocol=HTTP"),
          "start",
          null,
          null
      );
      
      server.invoke(new ObjectName("adaptor:protocol=HTTP"),
          "stop",
          null,
          null
      );
      
 
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

}

