
package book.jmx.examples;

import javax.management.*;
import javax.management.loading.*;
import java.io.*;
import java.net.*;

public class NetworkApp {

  public static void main(String[] args) {

    // create the MBean server
    MBeanServer server = 
        MBeanServerFactory.createMBeanServer();

    ObjectName name = null;
    
    try {

      // instantiate and register the MLet service
      name = new ObjectName("service:name=MLet");
      server.registerMBean(new MLet(), name);
    
      // load MLet text file
      server.invoke(name, "getMBeansFromURL",
        new Object[] {
            new URL("file:/E:/conf.mlet")
        },
        new String[] {
            URL.class.getName()
        }
      );

      // create the adaptor instance
      com.sun.jdmk.comm.HtmlAdaptorServer adaptor =
          new com.sun.jdmk.comm.HtmlAdaptorServer();

      server.registerMBean(adaptor, 
          new ObjectName("adaptor:protocol=HTTP"));

      adaptor.start();
    }
    catch (JMException e) {
      e.printStackTrace();
    }    
    catch (IOException e) {
      e.printStackTrace();
    }
  }
  
}

