
package book.jmx.examples;

import javax.management.*;

public class RMIAgent {

  final static String SERVER_DELEGATE = 
      "JMImplementation:type=MBeanServerDelegate";
  final static String AGENT_ID =
      "MBeanServerId";

  public static void main(String[] args) {
    MBeanServer server = 
        MBeanServerFactory.createMBeanServer();
    
    try {
      String agentID = (String)server.getAttribute(
          new ObjectName(SERVER_DELEGATE), AGENT_ID
      );

      server.createMBean("book.jmx.examples.RMIConnector",
          new ObjectName("Connector:transport=RMI"));
      server.invoke(new ObjectName("Connector:transport=RMI"),
          "startServer",
          new Object[] { agentID },
          new String[] { String.class.getName() }
      );      
    }
    catch (JMException e) {
      e.printStackTrace();
    }
  }

}

