
package book.jmx.examples;

import java.util.*;
import java.net.*;
import java.lang.reflect.*;
import java.rmi.*;
import electric.registry.*;


public class SOAPInvocationHandler 
    implements InvocationHandler, SOAPConnectorConstants {

  // the remote interface
  private MBeanServerInvoker invoker = null;
  
  public SOAPInvocationHandler(Properties props) 
      throws RegistryException {
          
    System.setProperty("electric.xml.io.serialize", "yes");
    
    // retrieve the connection properties
    String host = props.getProperty(HOST, "localhost");
    String port = props.getProperty(PORT, "8085");
    String name = props.getProperty(NAME);
    String path = props.getProperty(PATH, "");
    
    // retrieve the stub
    String url = "http://" + host + ":" + port + "/" + path + "/" + name;
    invoker = (MBeanServerInvoker)Registry.bind(url, MBeanServerInvoker.class);
        
  }   
    
  public Object invoke(Object proxy, Method method,
                       Object[] args) throws Throwable {
                       
    String methodName = method.getName();

    MethodInvocation mi = new MethodInvocation(method);
    mi.setParams(args);

    return invoker.invoke(mi);
  }
  
}
